#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_TCS34725.h>
#include <Servo.h>

Servo pickServo;
Servo dropServo;

Adafruit_TCS34725 tcs = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_50MS, TCS34725_GAIN_4X);

int color = 0;
int sensorOut = 7;

int detectColor() {
  uint16_t clear, red, green, blue;
  tcs.getRawData(&red, &green, &blue, &clear);

  Serial.print("Red = ");
  Serial.print(red);
  Serial.print("   ");

  Serial.print("Green = ");
  Serial.print(green);
  Serial.print("   ");

  Serial.print("Blue = ");
  Serial.print(blue);
  Serial.println("   ");

  if (red < 300 && green > 1000 && blue < 300) {
    color = 1; // Red
    Serial.println("Detected Color is = RED");
  } else if (red > 700 && green > 700 && blue < 300) {
    color = 2; // Orange
    Serial.println("Detected Color is = ORANGE");
  } else if (red < 300 && green > 1000 && blue > 1000) {
    color = 3; // Green
    Serial.println("Detected Color is = GREEN");
  } else if (red > 500 && green > 500 && blue < 500) {
    color = 4; // Yellow
    Serial.println("Detected Color is = YELLOW");
  } //else if (red < 300 && green < 300 && blue > 1000) {
  //  color = 5; // Blue
  //  Serial.println("Detected Color is = BLUE");
  //}

  return color;
}

void setup() {
  pinMode(sensorOut, INPUT);

  tcs.begin();

  pickServo.attach(9);
  dropServo.attach(10);

  Serial.begin(9600);
}

void loop() {
  pickServo.write(115);
  delay(600);

  for (int i = 115; i > 65; i--) {
    pickServo.write(i);
    delay(2);
  }

  delay(500);

  color = detectColor();

  delay(1000);

  switch (color) {
    case 1:
      dropServo.write(50);
      break;
    case 2:
      dropServo.write(80);
      break;
    case 3:
      dropServo.write(110);
      break;
    case 4:
      dropServo.write(140);
      break;
    case 5:
      dropServo.write(170);
      break;
    default:
      break;
  }

  delay(500);

  for (int i = 65; i > 29; i--) {
    pickServo.write(i);
    delay(2);
  }

  delay(300);

  for (int i = 29; i < 115; i++) {
    pickServo.write(i);
    delay(2);
  }

  color = 0;
}